Loading...
Searching...
No Matches
seqan3::phred68solexa Class Reference

Quality type for Solexa and deprecated Illumina formats. More...

`#include <seqan3/alphabet/quality/phred68solexa.hpp>`

Inheritance diagram for seqan3::phred68solexa:
[legend]

## Public Member Functions

Constructors, destructor and assignment
constexpr | phred68solexa () noexcept=default
| Defaulted.
constexpr | phred68solexa (phred68solexa const &) noexcept=default
| Defaulted.
constexpr | phred68solexa (phred68solexa &&) noexcept=default
| Defaulted.
constexpr phred68solexa & | operator= (phred68solexa const &) noexcept=default
| Defaulted.
constexpr phred68solexa & | operator= (phred68solexa &&) noexcept=default
| Defaulted.
| ~phred68solexa () noexcept=default
| Defaulted.
Public Member Functions inherited from seqan3::phred_base< phred68solexa, 68 >
constexpr phred68solexa & | assign_rank (rank_type const c) noexcept
| Assign from a numeric value.
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr phred_type | to_phred () const noexcept
| Return the alphabet's value in Phred score representation.
constexpr phred68solexa & | assign_phred (phred_type const p) noexcept
| Assign from the numeric Phred score value.
constexpr | phred_base (other_qual_type const &other) noexcept
| Allow explicit construction from any other quality type by means of the Phred score representation.
Public Member Functions inherited from seqan3::alphabet_base< derived_type, size, char_t >
constexpr | alphabet_base () noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base const &) noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base &&) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base const &) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base &&) noexcept=default
| Defaulted.
| ~alphabet_base () noexcept=default
| Defaulted.
constexpr char_type | to_char () const noexcept
| Return the letter as a character of char_type.
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr derived_type & | assign_char (char_type const chr) noexcept
| Assign from a character, implicitly converts invalid characters.
constexpr derived_type & | assign_rank (rank_type const c) noexcept
| Assign from a numeric value.

## Static Public Attributes

Member variables.
static constexpr phred_type | offset_phred {-5}
| The projection offset between Phred and rank score representation.
static constexpr char_type | offset_char {';'}
| The projection offset between char and rank score representation.
Static Public Attributes inherited from seqan3::phred_base< phred68solexa, 68 >
static constexpr detail::min_viable_uint_t< size > | alphabet_size
| The size of the alphabet, i.e. the number of different values it can take.
Static Public Attributes inherited from seqan3::alphabet_base< derived_type, size, char_t >
static constexpr detail::min_viable_uint_t< size > | alphabet_size = size
| The size of the alphabet, i.e. the number of different values it can take.

## Related Symbols

(Note that these are not member symbols.)
Quality literals
constexpr phred68solexa | operator""_phred68solexa (char const c) noexcept
| The seqan3::phred68solexa char literal.
constexpr std::vector< phred68solexa > | operator""_phred68solexa (char const *s, std::size_t n)
| The seqan3::phred68solexa string literal.

## Additional Inherited Members

Public Types inherited from seqan3::phred_base< phred68solexa, 68 >
using | phred_type
| The integer representation of the quality score.
Protected Types inherited from seqan3::alphabet_base< derived_type, size, char_t >
using | char_type = std::conditional_t<std::same_as<char_t, void>, char, char_t>
| The char representation; conditional needed to make semi alphabet definitions legal.
using | rank_type = detail::min_viable_uint_t<size - 1>
| The type of the alphabet when represented as a number (e.g. via to_rank()).

## Detailed Description

Quality type for Solexa and deprecated Illumina formats.

The phred68solexa quality alphabet represents the -5-based Phred score range [-5..62] mapped to the ASCII range [';' .. '~']. It represents the Solexa and the Illumina [1.0;1.8[ standard.

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/quality/phred68solexa.hpp>
#include <seqan3/core/debug_stream.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::phred68solexa letter{'@'_phred68solexa};
letter.assign_char(';');
seqan3::debug_stream << letter.to_phred() << '\n'; // prints "-5"
seqan3::debug_stream << letter.to_char() << '\n'; // prints ";"
letter.assign_phred(72); // Values exceeding the maximum are implicitly limited to the maximum phred value.
seqan3::debug_stream << letter.to_phred() << '\n'; // prints "62"
}
seqan3::alphabet_base::assign_char
constexpr derived_type & assign_char(char_type const chr) noexcept
Assign from a character, implicitly converts invalid characters.
Definition alphabet_base.hpp:160
seqan3::alphabet_base::to_char
constexpr char_type to_char() const noexcept
Return the letter as a character of char_type.
Definition alphabet_base.hpp:112
seqan3::phred68solexa
Quality type for Solexa and deprecated Illumina formats.
Definition phred68solexa.hpp:37
seqan3::phred_base::to_phred
constexpr phred_type to_phred() const noexcept
Return the alphabet's value in Phred score representation.
Definition phred_base.hpp:98
seqan3::phred_base::assign_phred
constexpr derived_type & assign_phred(phred_type const p) noexcept
Assign from the numeric Phred score value.
Definition phred_base.hpp:123
debug_stream.hpp
Provides seqan3::debug_stream and related types.
seqan3::debug_stream
debug_stream_type debug_stream
A global instance of seqan3::debug_stream_type.
Definition debug_stream.hpp:38
seqan3::literals
The SeqAn namespace for literals.
phred68solexa.hpp
Provides seqan3::phred68solexa quality scores.

This entity is stable. Since version 3.1.

## Friends And Related Symbol Documentation

## operator""_phred68solexa() [1/2]

std::vector< phred68solexa > operator""_phred68solexa | ( | char const * | s,
|  | std::size_t | n )

related

The seqan3::phred68solexa string literal.

Parameters

  [in] | s | A pointer to the character sequence to assign from.
  [in] | n | The length of the character sequence to assign from.

Returns
  seqan3::std::vector<seqan3::phred68solexa>

You can use this string literal to easily assign to std::vector<seqan3::phred68solexa>:

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/quality/phred68solexa.hpp>
int main()
{
using namespace seqan3::literals;
std::vector<seqan3::phred68solexa> sequence1{"##!!##"_phred68solexa};
std::vector<seqan3::phred68solexa> sequence2 = "##!!##"_phred68solexa;
auto sequence3 = "##!!##"_phred68solexa;
}
std::vector

This entity is stable. Since version 3.1.

## operator""_phred68solexa() [2/2]

phred68solexa operator""_phred68solexa | ( | char const | c | ) |

related

The seqan3::phred68solexa char literal.

Returns
  seqan3::phred68solexa

You can use this char literal to assign a seqan3::phred68solexa character:

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/quality/phred68solexa.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::phred68solexa letter1{'!'_phred68solexa};
auto letter2 = '!'_phred68solexa;
}

This entity is stable. Since version 3.1.

## Member Data Documentation

## offset_char

char_type seqan3::phred68solexa::offset_char {';'}

static constexpr

The projection offset between char and rank score representation.

This entity is stable. Since version 3.1.

## offset_phred

phred_type seqan3::phred68solexa::offset_phred {-5}

static constexpr

The projection offset between Phred and rank score representation.

This entity is stable. Since version 3.1.

The documentation for this class was generated from the following file:

- phred68solexa.hpp

Hide me